CREATE OR REPLACE FUNCTION ARQUIVO_DAC_60(
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_APURAC      IN VARCHAR,
   P_SISTEMA     IN VARCHAR,
   P_CALC        IN VARCHAR,
   P_GRUPPROD    IN VARCHAR,
   P_CONTADOR    IN NUMBER,
   P_SEQMAGNET   IN VARCHAR)
RETURN NUMBER
AS
   V_CONTADOR            NUMBER;
   V_CONTGERAL           NUMBER;
   V_CDIMPOSTRIB         VARCHAR2(2);
   V_REGNULO_63          VARCHAR2(500);
   V_REGNULO_64          VARCHAR2(500);
   V_TOTVRTRIBUTADO      NUMBER;/*VALOR TOTAL INICIAL DO ESTOQUE DOS PRODUTOS TRIBUTADOS*/
   V_TOTVRISENOUTROS     NUMBER;/*VALOR TOTAL INICIAL DO ESTOQUE DE OUTROS PRODUTOS*/
   V_TOTVRISENTO         NUMBER;/*VALOR TOTAL INICIAL DO ESTOQUE DOS PRODUTOS  NAO TRIBUTADOS*/
   V_TOTVRSUBSTRIB       NUMBER;/*VALOR TOTAL INICIAL DOS PRODUTOS QUE TEM SUBSTITUIO TRIBUTRIA*/
   V_TOTVRTRIBUTADOFIM   NUMBER;/*VALOR TOTAL FINAL DO ESTOQUE DOS PRODUTOS TRIBUTADOS*/
   V_TOTVRISENTOFIM      NUMBER;/*VALOR TOTAL FINAL DO ESTOQUE DOS PRODUTOS  NAO TRIBUTADOS*/
   V_TOTVRSUBSTRIBFIM    NUMBER;/*VALOR TOTAL FINAL DOS PRODUTOS QUE TEM SUBSTITUIO TRIBUTRIA*/
   V_TOTVRISENOUTROSFIM  NUMBER;/*VALOR TOTAL FINAL DO ESTOQUE DE OUTROS PRODUTOS*/
   V_VRTRIBUTADO         NUMBER;
   V_VRISENTO            NUMBER;
   V_VRSUBSTRIB          NUMBER;
   V_VRISENOUTROS        NUMBER;
   V_VRTRIBUTADOFIM      NUMBER;
   V_VRISENTOFIM         NUMBER;
   V_VRSUBSTRIBFIM       NUMBER;
   V_VRISENOUTROSFIM     NUMBER;
   V_INSERT              VARCHAR2(500);
   V_REGNULO_61          VARCHAR2(500);
   V_DATAINICIAL         DATE;
   V_DATAFIM             DATE;
BEGIN
   V_CONTADOR   := P_CONTADOR;
   V_REGNULO_63 := '0';
   V_REGNULO_64 := '0';
   V_TOTVRTRIBUTADO      := 0;
   V_TOTVRISENOUTROS     := 0;
   V_TOTVRISENTO         := 0;
   V_TOTVRSUBSTRIB       := 0;
   V_TOTVRTRIBUTADOFIM   := 0;
   V_TOTVRISENTOFIM      := 0;
   V_TOTVRSUBSTRIBFIM    := 0;
   V_TOTVRISENOUTROSFIM  := 0;
   V_VRTRIBUTADO         := 0;
   V_VRISENTO            := 0;
   V_VRSUBSTRIB          := 0;
   V_VRISENOUTROS        := 0;
   V_VRTRIBUTADOFIM      := 0;
   V_VRISENTOFIM         := 0;
   V_VRSUBSTRIBFIM       := 0;
   V_VRISENOUTROSFIM     := 0;

   /* BUSCA O ANO ANTERIOR A DATA INFORMADA */
   V_DATAINICIAL := TO_DATE('01/01/'||ABS(1 - SUBSTR(P_DTINICIAL,7,10)));
   V_DATAFIM     := TO_DATE('31/12/'||ABS(1 - SUBSTR(P_DTFINAL,7,10)));

   FOR C_REGISTRO_61 IN(
      SELECT '61'
              ||LPAD(NVL(T.CDMUNIEXPO,0),6,0)
              ||SUBSTR(LPAD(NVL(T.CDGRUPPROD,0),10,0),8,10)
              ||LPAD(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(NVL(T.QTITEMPROD,0),2)),'9999999990.0000')),'.',''),14,0)
              ||LPAD(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(NVL(T.VRTOTAITEM,0),2)),'999999999990.00')),'.',''),14,0)  AS REGISTRO_61
        FROM (SELECT CDARVPROD AS CDARVPROD,
                     '0'||CDMUNIEXPO AS CDMUNIEXPO,
                     SUM(IP.VRTOTAITEM - NVL(VRDESCITEM,0)) AS VRTOTAITEM,
                     SUM(QTITEMPROD) AS QTITEMPROD,
                     MAX((SELECT MAX(CDSUBGRPROD)
                            FROM PRSUBGRPROD
                           WHERE CDGRUPPROD = P_GRUPPROD
                             AND CDPRODUTO = P.CDPRODUTO)) AS CDGRUPPROD
                FROM ITEMPRODUTO IP, PRODUTO P, FORNECEDOR F,ENDEFORN EF, MUNICIPIO MU, NOTAFISCAL N,
				     (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
					    FROM IMPOSTONF I, MAPAAPURAC M
               WHERE M.CDEMPRESA = P_CDEMPRESA
                 AND M.CDIMPOSTO = P_CDIMPOSTO
                 AND M.DTINIPERIODO >= V_DATAINICIAL
                 AND M.DTFIMPERIODO <= V_DATAFIM
                 AND M.CDINSCESTA = P_CDINSCESTA
						 AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU) IM						 						
               WHERE IM.CDFILIAL = N.CDFILIAL 
                 AND IM.NRLANCTONF = N.NRLANCTONF
				 AND N.IDENTRSAIDOP = 'S' 
                 AND N.CDFILIAL = IP.CDFILIAL
                 AND N.NRLANCTONF = IP.NRLANCTONF
                 AND IP.CDPRODUTO = P.CDPRODUTO
                 AND EF.IDTPENDEFORN = 'P' 
                 AND N.CDFORNECED = F.CDFORNECED
                 AND F.CDFORNECED = EF.CDFORNECED
                 AND EF.CDPAIS = MU.CDPAIS
                 AND EF.SGESTADO = MU.SGESTADO
                 AND MU.SGESTADO = 'AL'
                 AND EF.CDMUNICIPIO = MU.CDMUNICIPIO
               GROUP BY CDARVPROD,CDMUNIEXPO
               UNION ALL
              SELECT CDARVPROD AS CDARVPROD,
                     '0'||CDMUNIEXPO AS CDMUNIEXPO,
                     SUM(IP.VRTOTAITEM - NVL(VRDESCITEM,0)) AS VRTOTAITEM,
                     SUM(QTITEMPROD) AS QTITEMPROD,
                     MAX((SELECT MAX(CDSUBGRPROD)
                            FROM PRSUBGRPROD
                           WHERE CDGRUPPROD = P_GRUPPROD
                             AND CDPRODUTO = P.CDPRODUTO)) AS CDGRUPPROD
                FROM ITEMPRODUTO IP, PRODUTO P, NOTAFISCAL N, CLIENTE E, ENDECLIE EC, MUNICIPIO MU,
					 (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
					    FROM IMPOSTONF I, MAPAAPURAC M
               WHERE M.CDEMPRESA = P_CDEMPRESA
                 AND M.CDIMPOSTO = P_CDIMPOSTO
                 AND M.DTINIPERIODO >= V_DATAINICIAL
                 AND M.DTFIMPERIODO <= V_DATAFIM
                 AND M.CDINSCESTA = P_CDINSCESTA
						 AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU) IM	
               WHERE IM.CDFILIAL = N.CDFILIAL 
                 AND IM.NRLANCTONF = N.NRLANCTONF 
                 AND N.CDFILIAL = IP.CDFILIAL
                 AND N.NRLANCTONF = IP.NRLANCTONF
                 AND IP.CDPRODUTO = P.CDPRODUTO
                 AND N.IDENTRSAIDOP = 'S'             
                 AND EC.IDTPENDECLIE = 'P' 
                 AND N.CDCLIENTE = E.CDCLIENTE
                 AND E.CDCLIENTE = EC.CDCLIENTE
                 AND EC.CDPAIS = MU.CDPAIS
                 AND EC.SGESTADO = MU.SGESTADO
                 AND MU.SGESTADO = 'AL'
                 AND EC.CDMUNICIPIO = MU.CDMUNICIPIO
               GROUP BY CDARVPROD, CDMUNIEXPO
               UNION ALL
              SELECT CDARVPROD AS CDARVPROD,
                     '0'||CDMUNIEXPO AS CDMUNIEXPO,
                     SUM(IP.VRTOTAITEM - NVL(VRDESCITEM,0)) AS VRTOTAITEM,
                     SUM(QTITEMPROD) AS QTITEMPROD,
                     MAX((SELECT MAX(CDSUBGRPROD)
                            FROM PRSUBGRPROD
                           WHERE CDGRUPPROD = P_GRUPPROD
                             AND CDPRODUTO = P.CDPRODUTO)) AS CDGRUPPROD
                FROM ITEMPRODUTO IP, PRODUTO P, NOTAFISCAL N, FILIAL F, ENDEFILI EF, MUNICIPIO MU,
					(SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
							FROM IMPOSTONF I, MAPAAPURAC M
               WHERE M.CDEMPRESA = P_CDEMPRESA
                 AND M.CDIMPOSTO = P_CDIMPOSTO
                 AND M.DTINIPERIODO >= V_DATAINICIAL
                 AND M.DTFIMPERIODO <= V_DATAFIM
                 AND M.CDINSCESTA = P_CDINSCESTA
							 AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU) IM
               WHERE IM.CDFILIAL = N.CDFILIAL 
                 AND IM.NRLANCTONF = N.NRLANCTONF 
                 AND N.CDFILIAL = IP.CDFILIAL
                 AND N.NRLANCTONF = IP.NRLANCTONF
                 AND IP.CDPRODUTO = P.CDPRODUTO
                 AND N.IDENTRSAIDOP = 'S'
                 AND EF.IDTPENDEFILI = 'P' 
                 AND N.CDFILIRECE = F.CDFILIAL
                 AND F.CDFILIAL = EF.CDFILIAL
                 AND EF.CDPAIS = MU.CDPAIS
                 AND EF.SGESTADO = MU.SGESTADO
                 AND MU.SGESTADO = 'AL'
                 AND EF.CDMUNICIPIO = MU.CDMUNICIPIO
               GROUP BY CDARVPROD, CDMUNIEXPO)T
       GROUP BY T.CDMUNIEXPO, T.CDGRUPPROD) LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),C_REGISTRO_61.REGISTRO_61,P_SEQMAGNET);
         V_REGNULO_61 := '1';
   END LOOP;

   IF V_REGNULO_61 = '0' THEN
      V_REGNULO_61 := '61'||LPAD(0,37,0);
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),V_REGNULO_61,P_SEQMAGNET);
   END IF;


   FOR C_REGISTRO_63 IN(
      SELECT '63'
             ||UPPER(SUBSTR(T.SGESTADO,1,2))
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRCONTABILNF),2),'999999999990.00')),'.',''),14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRBASECALCNF),2),'999999999990.00')),'.',''),14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VROUTROS),2),'999999999990.00')),'.',''),14,'0')
             ||RPAD('0',14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VROUTRASUB),2),'999999999990.00')),'.',''),14,'0') AS REGISTRO_63
        FROM
           (SELECT E.SGESTADO AS SGESTADO,
                   SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0)) AS VROUTROS,
                   SUM(DECODE(CDFISCALNF, '3', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'C',0),0)) AS VROUTRASUB
              FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M, FILIAL F, ENDEFILI E,MUNICIPIO MU
             WHERE M.CDEMPRESA    = P_CDEMPRESA
               AND M.CDINSCESTA   = P_CDINSCESTA
               AND M.CDIMPOSTO    = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
               AND I.CDFILIAL     = N.CDFILIAL
               AND I.NRLANCTONF   = N.NRLANCTONF
               AND N.IDENTRSAIDOP = 'E'
               AND N.CDFILIEMIT   = F.CDFILIAL
               AND F.CDFILIAL     = E.CDFILIAL
               AND E.CDPAIS       = MU.CDPAIS
               AND E.SGESTADO     = MU.SGESTADO
               AND E.CDMUNICIPIO  = MU.CDMUNICIPIO
               AND E.IDTPENDEFILI = 'P'
               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
            GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO AS SGESTADO,
                   SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0)) AS VROUTROS,
                   SUM(DECODE(CDFISCALNF, '3', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'C',0),0)) AS VROUTRASUB
              FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M,
                   CLIENTE C, ENDECLIE E, MUNICIPIO MU
             WHERE M.CDEMPRESA    = P_CDEMPRESA
               AND M.CDINSCESTA   = P_CDINSCESTA
               AND M.CDIMPOSTO    = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
               AND I.CDFILIAL     = N.CDFILIAL
               AND I.NRLANCTONF   = N.NRLANCTONF
               AND N.IDENTRSAIDOP = 'E'
               AND N.CDCLIENTE    = C.CDCLIENTE
               AND C.CDCLIENTE    = E.CDCLIENTE
               AND E.CDPAIS       = MU.CDPAIS
               AND E.SGESTADO     = MU.SGESTADO
               AND E.CDMUNICIPIO  = MU.CDMUNICIPIO
               AND IDTPENDECLIE   = 'P'
               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
             GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO AS SGESTADO,
                   SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0)) AS VROUTROS,
                   SUM(DECODE(CDFISCALNF, '3', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'C',0),0)) AS VROUTRASUB
              FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M,
                   FORNECEDOR F, ENDEFORN E,MUNICIPIO MU
             WHERE M.CDEMPRESA    = P_CDEMPRESA
               AND M.CDINSCESTA   = P_CDINSCESTA
               AND M.CDIMPOSTO    = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
               AND I.CDFILIAL     = N.CDFILIAL
               AND I.NRLANCTONF   = N.NRLANCTONF
               AND N.IDENTRSAIDOP = 'E'
               AND N.CDFORNECED   = F.CDFORNECED
               AND F.CDFORNECED   = E.CDFORNECED
               AND E.CDPAIS       = MU.CDPAIS
               AND E.SGESTADO     = MU.SGESTADO
               AND E.CDMUNICIPIO  = MU.CDMUNICIPIO
               AND E.IDTPENDEFORN = 'P'
               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
             GROUP BY E.SGESTADO) T
       GROUP BY T.SGESTADO) LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),C_REGISTRO_63.REGISTRO_63,P_SEQMAGNET);
         V_REGNULO_63 := '1';

   END LOOP;
   IF V_REGNULO_63 = '0' THEN
      V_REGNULO_63 :='63'||RPAD(' ',2,' ')||RPAD('0',70,'0');
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),V_REGNULO_63,P_SEQMAGNET);

   END IF;


   FOR C_REGISTRO_64 IN(
      SELECT '64'
             ||UPPER(SUBSTR(T.SGESTADO,1,2))
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRCONTABILNF),2),'999999999990.00')),'.',''),14,'0')
             ||RPAD('0',14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRBASECALCNF),2),'999999999990.00')),'.',''),14,'0')
             ||RPAD('0',14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VROUTROS),2),'999999999990.00')),'.',''),14,'0')
             ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRICMSRET),2),'999999999990.00')),'.',''),14,'0') AS REGISTRO_64
        FROM(
             SELECT UPPER(SUBSTR(E.SGESTADO,1,2)) AS SGESTADO,
                    NVL(SUM(I.VRCONTABILNF),0) AS VRCONTABILNF,
                    SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                    SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0))AS VROUTROS,
                    SUM(DECODE(CDFISCALNF, '1', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I',0),0)) AS VRICMSRET
               FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M, FILIAL F, ENDEFILI E, IMPOSTO P
              WHERE M.CDEMPRESA    = P_CDEMPRESA
                AND M.CDINSCESTA   = P_CDINSCESTA
                AND M.CDIMPOSTO    = P_CDIMPOSTO
                AND M.DTINIPERIODO >= V_DATAINICIAL
                AND M.DTFIMPERIODO <= V_DATAFIM
                AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU
                AND P.CDIMPOSTONFE = P_CDIMPOSTO
                AND I.CDIMPOSTO    = P.CDIMPOSTO
                AND I.CDFILIAL     = N.CDFILIAL
                AND I.NRLANCTONF   = N.NRLANCTONF
                AND N.IDENTRSAIDOP = 'S'
                AND I.IDIMPOSTONF  IN ('1', '2')
                AND N.CDFILIRECE   = F.CDFILIAL
                AND F.CDFILIAL     = E.CDFILIAL
                AND E.IDTPENDEFILI = 'P'
             GROUP BY E.SGESTADO
             UNION ALL
             SELECT UPPER(SUBSTR(E.SGESTADO,1,2)) AS SGESTADO,
                    NVL(SUM(I.VRCONTABILNF),0) AS VRCONTABILNF,
                    SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                    SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0))AS VROUTROS,
                    SUM(DECODE(CDFISCALNF, '1', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I',0),0)) AS VRICMSRET
               FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M, FORNECEDOR F, ENDEFORN E, IMPOSTO P
              WHERE M.CDEMPRESA    = P_CDEMPRESA
                AND M.CDINSCESTA   = P_CDINSCESTA
                AND M.CDIMPOSTO    = P_CDIMPOSTO
                AND M.DTINIPERIODO >= V_DATAINICIAL
                AND M.DTFIMPERIODO <= V_DATAFIM
                AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU
                AND I.CDFILIAL     = N.CDFILIAL
                AND I.NRLANCTONF   = N.NRLANCTONF
                AND P.CDIMPOSTONFE = P_CDIMPOSTO
                AND I.CDIMPOSTO    = P.CDIMPOSTO
                AND N.IDENTRSAIDOP = 'S'
                AND I.IDIMPOSTONF  IN ('1', '2')
                AND N.CDFORNECED   = F.CDFORNECED
                AND F.CDFORNECED   = E.CDFORNECED
                AND E.IDTPENDEFORN = 'P'
             GROUP BY E.SGESTADO
             UNION ALL
             SELECT UPPER(SUBSTR(E.SGESTADO,1,2)) AS SGESTADO,
                    NVL(SUM(I.VRCONTABILNF),0) AS VRCONTABILNF,
                    SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                    SUM(DECODE(I.CDFISCALNF,'3', I.VRCONTABILNF, 0))AS VROUTROS,
                    SUM(DECODE(CDFISCALNF, '1', VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '80', 'I',0),0)) AS VRICMSRET
               FROM NOTAFISCAL N, IMPOSTONF I, MAPAAPURAC M, CLIENTE C, ENDECLIE E, IMPOSTO P
              WHERE M.CDEMPRESA    = P_CDEMPRESA
                AND M.CDINSCESTA   = P_CDINSCESTA
                AND M.CDIMPOSTO    = P_CDIMPOSTO
                AND M.DTINIPERIODO >= V_DATAINICIAL
                AND M.DTFIMPERIODO <= V_DATAFIM
                AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU
                AND P.CDIMPOSTONFE = P_CDIMPOSTO
                AND I.CDIMPOSTO    = P.CDIMPOSTO
                AND I.CDFILIAL     = N.CDFILIAL
                AND I.NRLANCTONF   = N.NRLANCTONF
                AND N.IDENTRSAIDOP = 'S'
                AND I.IDIMPOSTONF  IN ('1', '2')
                AND N.CDCLIENTE    = C.CDCLIENTE
                AND C.CDCLIENTE    = E.CDCLIENTE
                AND E.IDTPENDECLIE = 'P'
              GROUP BY E.SGESTADO) T
       GROUP BY T.SGESTADO) LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),C_REGISTRO_64.REGISTRO_64,P_SEQMAGNET);
         V_REGNULO_64 := '1';

   END LOOP;
   IF V_REGNULO_64 = '0' THEN
      V_REGNULO_64 := '64'||RPAD(' ',2,' ')||RPAD('0',84,'0');
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         (LPAD(V_CONTADOR, 10, '0'),V_REGNULO_64,P_SEQMAGNET);

   END IF;


/*-----------------------INICIO_REGISTRO_65-----------------------------------*/
   /*BUSCA TODAS AS FILIAIS QUE UTILIZAM AQUELA INSCRIO ESTADUAL*/
   FOR C_FILIAL IN(
   SELECT F.CDFILIAL, F.CDINSCESTA
     FROM FILIAL F
    WHERE F.CDEMPRESA = P_CDEMPRESA
      AND F.CDINSCESTA = P_CDINSCESTA
    ORDER BY CDFILIAL)  LOOP

      /*ESTOQUE INICIAL DOS PRODUTOS */
      BEGIN
      SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'2',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'3',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'T',VRESTDIACON,0))
        INTO V_VRTRIBUTADO,V_VRISENTO,V_VRISENOUTROS,V_VRSUBSTRIB
        FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,C_FILIAL.CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = C_FILIAL.CDINSCESTA
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0
                    AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL = TO_DATE('31/12/'||(TO_CHAR(V_DATAINICIAL,'YYYY')-1))
                                             AND V.CDEMPRESA     = P_CDEMPRESA
                                             AND V.CDINSCESTA    = C_FILIAL.CDINSCESTA
                                             AND V.CDPRODUTO     = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0));

      EXCEPTION WHEN NO_DATA_FOUND THEN
          V_VRTRIBUTADO  := LPAD(0,14,0);
          V_VRISENTO     := LPAD(0,14,0);
          V_VRISENOUTROS := LPAD(0,14,0);
          V_VRSUBSTRIB   := LPAD(0,14,0);
      END;
      V_TOTVRTRIBUTADO  := V_TOTVRTRIBUTADO + NVL(V_VRTRIBUTADO,0);
      V_TOTVRISENTO     := V_TOTVRISENTO + NVL(V_VRISENTO,0);
      V_TOTVRISENOUTROS := V_TOTVRISENOUTROS + NVL(V_VRISENOUTROS,0);
      V_TOTVRSUBSTRIB   := V_TOTVRSUBSTRIB + NVL(V_VRSUBSTRIB,0);

     /*ESTOQUE FINAL DOS PRODUTOS */
      BEGIN
      SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'2',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'3',VRESTDIACON,0)),
             SUM(DECODE(CDFISCAL,'T',VRESTDIACON,0))
        INTO V_VRTRIBUTADOFIM,V_VRISENTOFIM,V_VRISENOUTROSFIM,V_VRSUBSTRIBFIM
        FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,C_FILIAL.CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = C_FILIAL.CDINSCESTA
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0
                    AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DATAFIM + 1
                                             AND V.CDEMPRESA     = P_CDEMPRESA
                                             AND V.CDINSCESTA    = C_FILIAL.CDINSCESTA
                                             AND V.CDPRODUTO     = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0));

      EXCEPTION WHEN NO_DATA_FOUND THEN
          V_VRTRIBUTADOFIM  := LPAD(0,14,0);
          V_VRISENTOFIM     := LPAD(0,14,0);
          V_VRISENOUTROSFIM := LPAD(0,14,0);
          V_VRSUBSTRIBFIM   := LPAD(0,14,0);
      END;
      V_TOTVRTRIBUTADOFIM  := V_TOTVRTRIBUTADOFIM + NVL(V_VRTRIBUTADOFIM,0);
      V_TOTVRISENTOFIM     := V_TOTVRISENTOFIM + NVL(V_VRISENTOFIM,0);
      V_TOTVRISENOUTROSFIM := V_TOTVRISENOUTROSFIM + NVL(V_VRISENOUTROSFIM,0);
      V_TOTVRSUBSTRIBFIM   := V_TOTVRSUBSTRIBFIM + NVL(V_VRSUBSTRIBFIM,0);

   END LOOP;/* DA FILIAL */

   V_INSERT := '65'
               ||TO_CHAR(V_DATAINICIAL,'YYYYMMDD')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRTRIBUTADO,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRTRIBUTADOFIM,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENTO,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENTOFIM,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRSUBSTRIB,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRSUBSTRIBFIM,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENOUTROS,0),2),'999999999990.00')),'.',''),14,'0')
               ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENOUTROSFIM,0),2),'999999999990.00')),'.',''),14,'0')
               ||P_APURAC||P_SISTEMA||P_CALC||LPAD(0,19,0);

    V_CONTADOR := NVL(V_CONTADOR,0)+1;
    INSERT INTO ARQMAGNETICO
       (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
       (LPAD(V_CONTADOR, 10, '0'),V_INSERT,P_SEQMAGNET);
       V_CONTGERAL := V_CONTGERAL + 1;

RETURN(LPAD(V_CONTADOR,10,0));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DAC_60','5.30.000'); END;
/

