/* Sistemas Integrados TEKNISA
  Integrao SPED FISCAL

Nome: C:\Web_407\Srv\Src\Cli\Sky\Sql\0009_LSGFUNO_USR_TRIBUTACAO.SQL

Descrio:
Funo para retornar o valor da base de reduo e do percentual de reduo do icms.

Criao:
10/02/2010 - Cleison Ferreira
*/
CREATE OR REPLACE FUNCTION USR_TRIBUTACAO
   (P_CDFILIAL     IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_NRLANCTONF   IN ITEMPRODUTO.NRLANCTONF%TYPE) RETURN STRING
AS
   V_VRIMPOSTONF_PIS     IMPOSTONF.VRIMPOSTONF%TYPE;
   V_VRALIQNF_PIS        IMPOSTONF.VRALIQNF%TYPE;
   V_VRIMPOSTONF_COFINS  IMPOSTONF.VRIMPOSTONF%TYPE;
   V_VRALIQNF_COFINS     IMPOSTONF.VRALIQNF%TYPE;
   V_VRIMPOSTONF_CSLL    IMPOSTONF.VRIMPOSTONF%TYPE;
   V_VRALIQNF_CSLL       IMPOSTONF.VRALIQNF%TYPE;
   V_VRIMPOSTONF         VARCHAR2(17);
   V_VRALIQNF            VARCHAR2(5);
   V_CDIMPOSTO           IMPOSTONF.CDIMPOSTO%TYPE;
   V_CDDARF              VARCHAR2(04);
   V_CDTRIBUTO           VARCHAR2(02);
   V_ESPTRIBUTO          VARCHAR2(02);
   V_CDRECEITA           VARCHAR2(06);
BEGIN
   BEGIN
      SELECT NVL(ROUND(VRIMPOSTONF,2),0),
             NVL(ROUND(VRALIQNF,2),0)
        INTO V_VRIMPOSTONF_PIS,
             V_VRALIQNF_PIS
        FROM IMPOSTONF
       WHERE CDFILIAL = P_CDFILIAL
         AND NRLANCTONF = P_NRLANCTONF
         AND CDIMPOSTO = '55';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPOSTONF_PIS := NULL;
   END;

   BEGIN
      SELECT NVL(ROUND(VRIMPOSTONF,2),0),
             NVL(ROUND(VRALIQNF,2),0)
        INTO V_VRIMPOSTONF_COFINS,
             V_VRALIQNF_COFINS
        FROM IMPOSTONF
       WHERE CDFILIAL = P_CDFILIAL
         AND NRLANCTONF = P_NRLANCTONF
         AND CDIMPOSTO = '65';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPOSTONF_COFINS := NULL;
   END;

   BEGIN
      SELECT NVL(ROUND(VRIMPOSTONF,2),0),
             NVL(ROUND(VRALIQNF,2),0)
        INTO V_VRIMPOSTONF_CSLL,
             V_VRALIQNF_CSLL
        FROM IMPOSTONF
       WHERE CDFILIAL = P_CDFILIAL
         AND NRLANCTONF = P_NRLANCTONF
         AND CDIMPOSTO = '67';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPOSTONF_CSLL := NULL;
   END;

   IF (V_VRIMPOSTONF_PIS IS NOT NULL) AND (V_VRIMPOSTONF_COFINS IS NOT NULL)
       AND (V_VRIMPOSTONF_CSLL IS NOT NULL) THEN
      V_VRIMPOSTONF := V_VRIMPOSTONF_PIS+V_VRIMPOSTONF_COFINS+V_VRIMPOSTONF_CSLL;
      V_VRIMPOSTONF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRIMPOSTONF,2),0),'000000000000000.00'),'.',''));
      V_VRALIQNF := V_VRALIQNF_PIS+V_VRALIQNF_COFINS+V_VRALIQNF_CSLL;
      V_VRALIQNF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRALIQNF,2),0),'000.00'),'.',''));
      V_CDIMPOSTO := '55';
      V_CDDARF := '5952';
      V_CDTRIBUTO := '31';
      V_ESPTRIBUTO := '01';
      V_CDRECEITA := '595202';
   ELSIF (V_VRIMPOSTONF_PIS IS NOT NULL) AND (V_VRIMPOSTONF_COFINS IS NULL)
        AND (V_VRIMPOSTONF_CSLL IS NULL) THEN
      V_VRIMPOSTONF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRIMPOSTONF_PIS,2),0),'000000000000000.00'),'.',''));
      V_VRALIQNF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRALIQNF_PIS,2),0),'000.00'),'.',''));
      V_CDIMPOSTO := '55';
      V_CDDARF := '5979';
      V_CDTRIBUTO := '06';
      V_ESPTRIBUTO := '01';
      V_CDRECEITA := '597904';
   ELSIF (V_VRIMPOSTONF_PIS IS NULL) AND (V_VRIMPOSTONF_COFINS IS NOT NULL)
        AND (V_VRIMPOSTONF_CSLL IS NULL) THEN
      V_VRIMPOSTONF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRIMPOSTONF_COFINS,2),0),'000000000000000.00'),'.',''));
      V_VRALIQNF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRALIQNF_COFINS,2),0),'000.00'),'.',''));
      V_CDIMPOSTO := '65';
      V_CDDARF := '5960';
      V_CDTRIBUTO := '07';
      V_ESPTRIBUTO := '01';
      V_CDRECEITA := '596004';
   ELSIF (V_VRIMPOSTONF_PIS IS NULL) AND (V_VRIMPOSTONF_COFINS IS NULL)
        AND (V_VRIMPOSTONF_CSLL IS NOT NULL) THEN
      V_VRIMPOSTONF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRIMPOSTONF_CSLL,2),0),'000000000000000.00'),'.',''));
      V_VRALIQNF := LTRIM(REPLACE(TO_CHAR(NVL(ROUND(V_VRALIQNF_CSLL,2),0),'000.00'),'.',''));
      V_CDIMPOSTO := '67';
      V_CDDARF := '5987';
      V_CDTRIBUTO := '05';
      V_ESPTRIBUTO := '01';
      V_CDRECEITA := '598704';
   ELSIF (V_VRIMPOSTONF_PIS IS NULL) AND (V_VRIMPOSTONF_COFINS IS NULL)
        AND (V_VRIMPOSTONF_CSLL IS NULL) THEN
      V_VRIMPOSTONF := '00000000000000000';
      V_VRALIQNF := '00000';
      V_CDIMPOSTO := '@@';
      V_CDDARF := '0000';
      V_CDTRIBUTO := '00';
      V_ESPTRIBUTO := '00';
      V_CDRECEITA := '000000';
   END IF;

   RETURN(V_CDIMPOSTO||V_CDDARF||V_CDTRIBUTO||V_ESPTRIBUTO||V_CDRECEITA||V_VRIMPOSTONF||V_VRALIQNF);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_TRIBUTACAO','4.07.000'); END;
/
